package nc.vo.gl.cashflowcase;

import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Vector;
import nc.gl.utils.BDMultiLangUtil;
import nc.gl.utils.GLMultiLangUtil;
import nc.vo.bd.accassitem.AccAssItemVO;
import nc.vo.bd.account.AccountVO;
import nc.vo.fipub.freevalue.account.proxy.AccAssGL;
import nc.vo.gateway60.itfs.AccountUtilGL;
import nc.vo.gateway60.itfs.Currency;
import nc.vo.gl.cashflowcase.CFPubProxy;
import nc.vo.gl.cashflowcase.CashFlowDetail;
import nc.vo.gl.cashflowcase.CashflowForVoucherVO;
import nc.vo.gl.cashflowcase.CashflowVO;
import nc.vo.gl.cashflowcase.CashflowcaseVO;
import nc.vo.gl.cashflowcase.QueryConditionVO;
import nc.vo.gl.cashflowcase.VoucherCFVO;
import nc.vo.gl.pubvoucher.DetailVO;
import nc.vo.glcom.ass.AssVO;
import nc.vo.ml.NCLangRes4VoTransl;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nccloud.commons.lang.StringUtils;

public class CfVOAdapter {

   public static HashMap itemflag_map = new HashMap();
   public static HashMap cashflowname_map = new HashMap();
   public static HashMap cashflow_map = new HashMap();
   public static HashMap subj_map = new HashMap();


   public void VoucherVoToCfVoucherVO() {
   }

   public void CfVoucherVOToVocherVO() throws BusinessException {
   }

   public static boolean isMainCf(String pk_cashflow) throws BusinessException {
      QueryConditionVO queryvo = new QueryConditionVO();
      queryvo.setPk_cashflow(pk_cashflow);
      CashFlowDetail[] details = CFPubProxy.getRemoteCashFlowCase().getCashFlow(queryvo);
      return details[0].getM_itemflag().intValue() != 1;
   }

   public static CashflowForVoucherVO constructUnanalyzedVO(DetailVO detailVO) {
      CashflowForVoucherVO destVO = new CashflowForVoucherVO();
      destVO.setM_detailno(detailVO.getDetailindex());
      destVO.setM_subjname(getName(detailVO));
      destVO.setPk_unit(detailVO.getPk_unit());
      destVO.setPk_liabilitycenter(detailVO.getPk_liabilitycenter());
      if(detailVO.getPk_detail() != null && !detailVO.getPk_detail().trim().equals("")) {
         destVO.setM_pk_detail(detailVO.getPk_detail());
      } else {
         destVO.setM_pk_detail(detailVO.getPk_voucher() + "-" + detailVO.getDetailindex().toString());
      }

      destVO.setM_pk_accsubj(detailVO.getPk_accasoa());
      destVO.setM_pk_voucher(detailVO.getPk_voucher());
      destVO.setAssid(detailVO.getAssid());
      AssVO[] assvos = detailVO.getAss();
      if(assvos != null && assvos.length > 0) {
         StringBuffer zero = new StringBuffer("");
         AssVO[] var4 = assvos;
         int var5 = assvos.length;

         for(int var6 = 0; var6 < var5; ++var6) {
            AssVO assvo = var4[var6];
            if(StringUtils.isEmpty(assvo.getChecktypename())) {
               AccAssItemVO str = AccAssGL.getAccAssItemVOByPk(assvo.getPk_Checktype());
               assvo.setChecktypename(GLMultiLangUtil.getMultiName(str));
            }

            String var10 = "【" + assvo.getChecktypename() + "：" + (assvo.getCheckvaluename() == null?"~":assvo.getCheckvaluename()) + "】";
            zero.append(var10);
         }

         destVO.setM_ass(zero.toString());
      }

      destVO.setM_dr(detailVO.getDirection()?NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000035"):NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000252"));
      destVO.setLocalCreditAmount(detailVO.getLocalcreditamount());
      destVO.setLocalDebitAmount(detailVO.getLocaldebitamount());
      destVO.setCreditAmount(detailVO.getCreditamount());
      destVO.setDebitAmount(detailVO.getDebitamount());
      destVO.setM_pk_currtype(detailVO.getPk_currtype());
      destVO.setGroupDebitAmount(detailVO.getGroupdebitamount());
      destVO.setGroupCreditAmount(detailVO.getGroupcreditamount());
      destVO.setGlobalDebitAmount(detailVO.getGlobaldebitamount());
      destVO.setGlobalCreditAmount(detailVO.getGlobalcreditamount());
      if(detailVO.getGroupcreditamount() != null && !detailVO.getGroupcreditamount().equals(UFDouble.ZERO_DBL)) {
         destVO.setGroupAmount(detailVO.getGroupcreditamount());
      } else {
         destVO.setGroupAmount(detailVO.getGroupdebitamount());
      }

      if(detailVO.getGlobalcreditamount() != null && !detailVO.getGlobalcreditamount().equals(UFDouble.ZERO_DBL)) {
         destVO.setGlobalAmount(detailVO.getGlobalcreditamount());
      } else {
         destVO.setGlobalAmount(detailVO.getGlobaldebitamount());
      }

      UFDouble var9 = new UFDouble(0);
      if(detailVO.getCreditamount() != null && !detailVO.getCreditamount().equals(var9)) {
         destVO.setOccAmount(detailVO.getCreditamount());
      }

      if(detailVO.getDebitamount() != null && !detailVO.getDebitamount().equals(var9)) {
         destVO.setOccAmount(detailVO.getDebitamount());
      }

      if(detailVO.getLocalcreditamount() != null && !detailVO.getLocalcreditamount().equals(var9)) {
         destVO.setLocalAmount(detailVO.getLocalcreditamount());
      }

      if(detailVO.getLocaldebitamount() != null && !detailVO.getLocaldebitamount().equals(var9)) {
         destVO.setLocalAmount(detailVO.getLocaldebitamount());
      }

      return destVO;
   }

   public static Vector[] constructCashflowForVoucherVO(DetailVO detailVO) throws Exception {
      CashflowcaseVO[] currCaseVos = detailVO.getCashFlow();
      Vector unanalyzedDetails = new Vector();
      Vector analyzedDetails = new Vector();
      if((currCaseVos == null || currCaseVos.length == 0) && isNonCfSubj(detailVO)) {
         unanalyzedDetails.add(constructUnanalyzedVO(detailVO));
      }

      HashMap map = new HashMap();
      if(currCaseVos != null && currCaseVos.length > 0) {
         for(int cfvos = 0; cfvos < currCaseVos.length; ++cfvos) {
            if(map.get(currCaseVos[cfvos].getPk_cashflow()) == null) {
               map.put(currCaseVos[cfvos].getPk_cashflow() + "_" + currCaseVos[cfvos].getM_pk_currtype() + "_" + (StringUtils.isEmpty(currCaseVos[cfvos].getPk_innercorp())?"":currCaseVos[cfvos].getPk_innercorp()), currCaseVos[cfvos]);
            }
         }
      }

      Collection var7 = map.values();
      CashflowcaseVO[] cfarray = (CashflowcaseVO[])var7.toArray(new CashflowcaseVO[0]);
      analyzedDetails.addAll(constructOneDetail(detailVO, cfarray));
      return new Vector[]{unanalyzedDetails, analyzedDetails};
   }

   public static Vector constructOneDetail(DetailVO detailVO, CashflowcaseVO[] caseVos) throws Exception {
      Vector result = new Vector();

      for(int i = 0; i < caseVos.length; ++i) {
         CashflowVO cf = getCashflow(caseVos[i].getPk_cashflow());
         CashflowForVoucherVO destVO = new CashflowForVoucherVO();
         destVO.setPk_innercorp(caseVos[i].getPk_innercorp());
         destVO.setPk_unit(detailVO.getPk_unit());
         destVO.setPk_liabilitycenter(detailVO.getPk_liabilitycenter());
         destVO.setM_detailno(detailVO.getDetailindex());
         cashflow_map.put(caseVos[i].getPk_cashflow(), cf);
         if(cf.getItemflag() != null && !cf.getItemflag().equals("Y")) {
            destVO.setPk_cashflow_ass(caseVos[i].getPk_cashflow());
            destVO.setSubCFItem(cf.getCfitemname());
         } else {
            destVO.setPk_cashflow_main(caseVos[i].getPk_cashflow());
            destVO.setMainCfItem(cf.getCfitemname());
         }

         if(detailVO.getPk_detail() != null && !detailVO.getPk_detail().trim().equals("")) {
            destVO.setM_pk_detail(detailVO.getPk_detail());
         } else {
            destVO.setM_pk_detail(detailVO.getPk_voucher() + "-" + detailVO.getDetailindex().toString());
         }

         destVO.setM_pk_accsubj(detailVO.getPk_accasoa());
         destVO.setM_pk_voucher(detailVO.getPk_voucher());
         destVO.setAssid(detailVO.getAssid());
         AssVO[] assvos = detailVO.getAss();
         if(assvos != null && assvos.length > 0) {
            StringBuffer buffer = new StringBuffer("");
            AssVO[] var8 = assvos;
            int var9 = assvos.length;

            for(int var10 = 0; var10 < var9; ++var10) {
               AssVO assvo = var8[var10];
               if(StringUtils.isEmpty(assvo.getChecktypename())) {
                  AccAssItemVO str = AccAssGL.getAccAssItemVOByPk(assvo.getPk_Checktype());
                  assvo.setChecktypename(GLMultiLangUtil.getMultiName(str));
               }

               String var13 = "【" + assvo.getChecktypename() + "：" + (assvo.getCheckvaluename() == null?"~":assvo.getCheckvaluename()) + "】";
               buffer.append(var13);
            }

            destVO.setM_ass(buffer.toString());
         }

         destVO.setM_pk_currtype(caseVos[i].getM_pk_currtype());
         destVO.setOccAmount(caseVos[i].getMoney());
         destVO.setLocalAmount(caseVos[i].getMoneymain());
         destVO.setGroupAmount(caseVos[i].getMoneygroup());
         destVO.setGlobalAmount(caseVos[i].getMoneyglobal());
         destVO.setDebitAmount(detailVO.getDebitamount());
         destVO.setCreditAmount(detailVO.getCreditamount());
         destVO.setLocalCreditAmount(detailVO.getLocalcreditamount());
         destVO.setLocalDebitAmount(detailVO.getLocaldebitamount());
         destVO.setGroupCreditAmount(detailVO.getGroupcreditamount());
         destVO.setGroupDebitAmount(detailVO.getGroupdebitamount());
         destVO.setGlobalCreditAmount(detailVO.getGlobalcreditamount());
         destVO.setGlobalDebitAmount(detailVO.getGlobaldebitamount());
         destVO.setM_dr(detailVO.getDirection()?NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000035"):NCLangRes4VoTransl.getNCLangRes().getStrByID("2002gl55", "UPP2002gl55-000252"));
         result.add(destVO);
      }

      return result;
   }

   public static void mergeCfVoucherVO(Vector vector) {
      if(vector != null) {
         Vector indice = new Vector();
         int temparray = 0;

         while(temparray < vector.size()) {
            CashflowForVoucherVO i = (CashflowForVoucherVO)vector.get(temparray);
            int j = temparray + 1;

            while(true) {
               if(j < vector.size()) {
                  label49: {
                     CashflowForVoucherVO destVO = (CashflowForVoucherVO)vector.get(j);
                     if(i.getM_pk_detail() != null && i.getM_pk_detail().equals(i.getM_pk_detail()) && i.getOccAmount().equals(destVO.getOccAmount()) && i.getLocalAmount().equals(destVO.getLocalAmount()) && i.getM_pk_currtype().equals(destVO.getM_pk_currtype())) {
                        if(i.getPk_cashflow_ass() != null && destVO.getPk_cashflow_main() != null) {
                           destVO.setPk_cashflow_ass(i.getPk_cashflow_ass());
                           destVO.setSubCFItem(i.getSubCFItem());
                           indice.add(Integer.valueOf(temparray));
                           break label49;
                        }

                        if(destVO.getPk_cashflow_ass() != null && i.getPk_cashflow_main() != null) {
                           i.setPk_cashflow_ass(destVO.getPk_cashflow_ass());
                           i.setSubCFItem(destVO.getSubCFItem());
                           indice.add(Integer.valueOf(j));
                           break label49;
                        }
                     }

                     ++j;
                     continue;
                  }
               }

               ++temparray;
               break;
            }
         }

         Object[] var6 = indice.toArray();
         Arrays.sort(var6);

         for(int var7 = var6.length - 1; var7 >= 0; --var7) {
            vector.remove(((Integer)var6[var7]).intValue());
         }

      }
   }

   public static VoucherCFVO[] transferToVoucherVO(DetailVO[] srcvos) throws BusinessException {
      if(srcvos != null && srcvos.length != 0) {
         Vector transferedVOs = new Vector();
         HashSet pk_accasoaSet = new HashSet();

         for(int accountVOMap = 0; accountVOMap < srcvos.length; ++accountVOMap) {
            if(srcvos[accountVOMap] != null && srcvos[accountVOMap].getPk_accasoa() != null) {
               pk_accasoaSet.add(srcvos[accountVOMap].getPk_accasoa());
            }
         }

         HashMap var10 = new HashMap();
         AccountVO[] subjs = AccountUtilGL.queryByPks((String[])pk_accasoaSet.toArray(new String[0]), srcvos[0].getPrepareddate().toString());
         int retVOs;
         if(null != subjs && subjs.length > 0) {
            for(retVOs = 0; retVOs < subjs.length; ++retVOs) {
               var10.put(subjs[retVOs].getPk_accasoa(), subjs[retVOs]);
            }
         }

         for(retVOs = 0; retVOs < srcvos.length; ++retVOs) {
            if(srcvos[retVOs] != null && srcvos[retVOs].getPk_accasoa() != null) {
               VoucherCFVO destVO = new VoucherCFVO();
               AccountVO subj = (AccountVO)var10.get(srcvos[retVOs].getPk_accasoa());
               if(null != subj) {
                  destVO.setCashbankflag(subj.getCashtype());
               }

               destVO.setPk_group(srcvos[retVOs].getPk_group());
               destVO.setPk_glorgbook(srcvos[retVOs].getPk_glorgbook());
               destVO.setPk_unit(srcvos[retVOs].getPk_unit());
               destVO.setPk_liabilitycenter(srcvos[retVOs].getPk_liabilitycenter());
               destVO.setPk_corp(srcvos[retVOs].getPk_org());
               destVO.setM_assid(srcvos[retVOs].getAssid());
               if(srcvos[retVOs].getPk_detail() != null && !srcvos[retVOs].getPk_detail().trim().equals("")) {
                  destVO.setPk_detail(srcvos[retVOs].getPk_detail());
               } else {
                  destVO.setPk_detail(srcvos[retVOs].getPk_voucher() + "-" + srcvos[retVOs].getDetailindex().toString());
               }

               boolean needTransferCreditAmount = (destVO.getCashbankflag() == null || destVO.getCashbankflag().intValue() == 0) && srcvos[retVOs].getCreditamount().doubleValue() == 0.0D && srcvos[retVOs].getLocalcreditamount().doubleValue() != 0.0D;
               boolean needTransferDebitAmount = (destVO.getCashbankflag() == null || destVO.getCashbankflag().intValue() == 0) && srcvos[retVOs].getDebitamount().doubleValue() == 0.0D && srcvos[retVOs].getLocaldebitamount().doubleValue() != 0.0D;
               if(needTransferCreditAmount) {
                  destVO.setCreditamount(getUFDoubleValue(srcvos[retVOs].getLocalcreditamount()));
               } else {
                  destVO.setCreditamount(getUFDoubleValue(srcvos[retVOs].getCreditamount()));
               }

               if(needTransferDebitAmount) {
                  destVO.setCreditamount(getUFDoubleValue(srcvos[retVOs].getLocaldebitamount()));
               } else {
                  destVO.setDebitamount(getUFDoubleValue(srcvos[retVOs].getDebitamount()));
               }

               destVO.setAnalyzeType("");
               destVO.setM_currdigit(Integer.valueOf(2));
               destVO.setM_Main_Creditamount(getUFDoubleValue(srcvos[retVOs].getLocalcreditamount()));
               destVO.setM_Main_Debitamount(getUFDoubleValue(srcvos[retVOs].getLocaldebitamount()));
               destVO.setM_money(srcvos[retVOs].getCreditamount() != null && !srcvos[retVOs].getCreditamount().equals(UFDouble.ZERO_DBL)?srcvos[retVOs].getCreditamount():srcvos[retVOs].getDebitamount());
               destVO.setM_pk_currtype(srcvos[retVOs].getPk_currtype());
               destVO.setM_subject(srcvos[retVOs].getAccsubjname());
               destVO.setM_Ass_Creditamount(getUFDoubleValue(srcvos[retVOs].getFraccreditamount()));
               destVO.setM_Ass_Debitamount(getUFDoubleValue(srcvos[retVOs].getFracdebitamount()));
               destVO.setM_Group_Debitamount(getUFDoubleValue(srcvos[retVOs].getGroupdebitamount()));
               destVO.setM_Group_Creditamount(getUFDoubleValue(srcvos[retVOs].getGroupcreditamount()));
               destVO.setM_Global_Debitamount(getUFDoubleValue(srcvos[retVOs].getGlobaldebitamount()));
               destVO.setM_Global_Creditamount(getUFDoubleValue(srcvos[retVOs].getGlobalcreditamount()));
               destVO.setPk_subject(srcvos[retVOs].getPk_accasoa());
               destVO.setPk_voucher(srcvos[retVOs].getPk_voucher());
               destVO.setPk_vouchertype(srcvos[retVOs].getPk_vouchertype());
               destVO.setPrepareddate(srcvos[retVOs].getPrepareddate());
               transferedVOs.add(destVO);
            }
         }

         VoucherCFVO[] var11 = new VoucherCFVO[transferedVOs.size()];
         transferedVOs.copyInto(var11);
         return var11;
      } else {
         return null;
      }
   }

   public static VoucherCFVO[] transferToVoucherVO(DetailVO[] srcvos, Map subjmap) throws BusinessException {
      if(srcvos != null && srcvos.length != 0) {
         Vector transferedVOs = new Vector();

         for(int retVOs = 0; retVOs < srcvos.length; ++retVOs) {
            AccountVO accountVO = (AccountVO)subjmap.get(srcvos[retVOs].getPk_accasoa());
            if(srcvos[retVOs] != null && srcvos[retVOs].getPk_accasoa() != null && accountVO != null && accountVO.getAccproperty().intValue() == 0) {
               VoucherCFVO destVO = new VoucherCFVO();
               destVO.setCashbankflag(accountVO.getCashtype());
               destVO.setPk_group(srcvos[retVOs].getPk_group());
               destVO.setPk_glorgbook(srcvos[retVOs].getPk_glorgbook());
               destVO.setPk_unit(srcvos[retVOs].getPk_unit());
               destVO.setPk_corp(srcvos[retVOs].getPk_org());
               destVO.setM_assid(srcvos[retVOs].getAssid());
               if(srcvos[retVOs].getPk_detail() != null && !srcvos[retVOs].getPk_detail().trim().equals("")) {
                  destVO.setPk_detail(srcvos[retVOs].getPk_detail());
               } else {
                  destVO.setPk_detail(srcvos[retVOs].getPk_voucher() + "-" + srcvos[retVOs].getDetailindex().toString());
               }

               boolean needTransferCreditAmount = (destVO.getCashbankflag() == null || destVO.getCashbankflag().intValue() == 0) && srcvos[retVOs].getCreditamount().doubleValue() == 0.0D && srcvos[retVOs].getLocalcreditamount().doubleValue() != 0.0D;
               boolean needTransferDebitAmount = (destVO.getCashbankflag() == null || destVO.getCashbankflag().intValue() == 0) && srcvos[retVOs].getDebitamount().doubleValue() == 0.0D && srcvos[retVOs].getLocaldebitamount().doubleValue() != 0.0D;
               if(needTransferCreditAmount) {
                  destVO.setCreditamount(getUFDoubleValue(srcvos[retVOs].getLocalcreditamount()));
               } else {
                  destVO.setCreditamount(getUFDoubleValue(srcvos[retVOs].getCreditamount()));
               }

               if(needTransferDebitAmount) {
                  destVO.setCreditamount(getUFDoubleValue(srcvos[retVOs].getLocaldebitamount()));
               } else {
                  destVO.setDebitamount(getUFDoubleValue(srcvos[retVOs].getDebitamount()));
               }

               destVO.setAnalyzeType("");
               destVO.setM_currdigit(Integer.valueOf(2));
               destVO.setM_Main_Creditamount(getUFDoubleValue(srcvos[retVOs].getLocalcreditamount()));
               destVO.setM_Main_Debitamount(getUFDoubleValue(srcvos[retVOs].getLocaldebitamount()));
               if(Currency.isStartGroupCurr(srcvos[retVOs].getPk_group())) {
                  destVO.setM_Group_Creditamount(getUFDoubleValue(srcvos[retVOs].getGroupcreditamount()));
                  destVO.setM_Group_Debitamount(getUFDoubleValue(srcvos[retVOs].getGroupdebitamount()));
               }

               if(Currency.isStartGlobalCurr()) {
                  destVO.setM_Global_Creditamount(getUFDoubleValue(srcvos[retVOs].getGlobalcreditamount()));
                  destVO.setM_Global_Debitamount(getUFDoubleValue(srcvos[retVOs].getGlobaldebitamount()));
               }

               destVO.setM_money(srcvos[retVOs].getCreditamount() != null && !srcvos[retVOs].getCreditamount().equals(UFDouble.ZERO_DBL)?srcvos[retVOs].getCreditamount():srcvos[retVOs].getDebitamount());
               destVO.setM_pk_currtype(srcvos[retVOs].getPk_currtype());
               destVO.setM_subject(srcvos[retVOs].getAccsubjname());
               destVO.setM_Ass_Creditamount(getUFDoubleValue(srcvos[retVOs].getFraccreditamount()));
               destVO.setM_Ass_Debitamount(getUFDoubleValue(srcvos[retVOs].getFracdebitamount()));
               destVO.setPk_subject(srcvos[retVOs].getPk_accasoa());
               destVO.setPk_voucher(srcvos[retVOs].getPk_voucher());
               destVO.setPk_vouchertype(srcvos[retVOs].getPk_vouchertype());
               destVO.setPrepareddate(srcvos[retVOs].getPrepareddate());
               transferedVOs.add(destVO);
            }
         }

         VoucherCFVO[] var8 = new VoucherCFVO[transferedVOs.size()];
         transferedVOs.copyInto(var8);
         return var8;
      } else {
         return null;
      }
   }

   public static CashflowForVoucherVO[] refreshCfVOByCaseVO(CashflowForVoucherVO[] srcvos, CashflowcaseVO[] casevos) throws Exception {
      if(casevos != null && casevos.length != 0) {
         HashSet resultVect = new HashSet();
         int result = 0;

         while(result < casevos.length) {
            int i = 0;

            while(true) {
               if(i < srcvos.length) {
                  if(!casevos[result].getPk_detail().equals(srcvos[i].getM_pk_detail())) {
                     ++i;
                     continue;
                  }

                  CashflowForVoucherVO vo = (CashflowForVoucherVO)srcvos[i].clone();
                  vo.setPk_cashflow_ass((String)null);
                  vo.setPk_cashflow_main((String)null);
                  vo.setSubCFItem((String)null);
                  vo.setMainCfItem((String)null);
                  CashflowForVoucherVO targetvo;
                  if(isMainCfItem(casevos[result])) {
                     targetvo = null;
                     if(srcvos[i].getPk_cashflow_main() == null) {
                        targetvo = vo;
                     } else {
                        targetvo = (CashflowForVoucherVO)vo.clone();
                     }

                     targetvo.setPk_innercorp(casevos[result].getPk_innercorp());
                     targetvo.setPk_unit(casevos[result].getPk_unit());
                     targetvo.setM_pk_currtype(casevos[result].getM_pk_currtype());
                     targetvo.setPk_cashflow_main(casevos[result].getPk_cashflow());
                     targetvo.setMainCfItem(getCashflow(casevos[result].getPk_cashflow()).getCfitemname());
                     targetvo.setOccAmount(casevos[result].getMoney());
                     targetvo.setLocalAmount(casevos[result].getMoneymain());
                     targetvo.setGroupAmount(casevos[result].getMoneygroup());
                     targetvo.setGlobalAmount(casevos[result].getMoneyglobal());
                     resultVect.add(targetvo);
                  } else {
                     targetvo = null;
                     if(srcvos[i].getPk_cashflow_ass() == null) {
                        targetvo = vo;
                     } else {
                        targetvo = (CashflowForVoucherVO)vo.clone();
                     }

                     targetvo.setPk_innercorp(casevos[result].getPk_innercorp());
                     targetvo.setPk_unit(casevos[result].getPk_unit());
                     targetvo.setM_pk_currtype(casevos[result].getM_pk_currtype());
                     targetvo.setPk_cashflow_ass(casevos[result].getPk_cashflow());
                     targetvo.setSubCFItem(getCashflow(casevos[result].getPk_cashflow()).getCfitemname());
                     targetvo.setOccAmount(casevos[result].getMoney());
                     targetvo.setLocalAmount(casevos[result].getMoneymain());
                     targetvo.setGroupAmount(casevos[result].getMoneygroup());
                     targetvo.setGlobalAmount(casevos[result].getMoneyglobal());
                     resultVect.add(targetvo);
                  }
               }

               ++result;
               break;
            }
         }

         CashflowForVoucherVO[] var7 = new CashflowForVoucherVO[resultVect.size()];
         resultVect.toArray(var7);
         return var7;
      } else {
         return new CashflowForVoucherVO[0];
      }
   }

   public static CashflowVO getCashflow(String pk_cashflow) throws BusinessException {
      CashflowVO vo = (CashflowVO)cashflow_map.get(pk_cashflow);
      if(vo == null) {
         CashflowVO queryvo = new CashflowVO();
         queryvo.setPk_cashflow(pk_cashflow);
         vo = CFPubProxy.getRemoteCashFlowCaseIO().getCashflow(queryvo, new Boolean(false));
         BDMultiLangUtil.replaceObjNameWithMDID(new CashflowVO[]{vo}, "getPk_cashflow", "setCfitemname", "08d4138b-a7b5-42fd-94bc-bb6eb7ac0fdc");
         cashflow_map.put(pk_cashflow, vo);
      }

      return vo;
   }

   private static UFDouble getUFDoubleValue(Object value) {
      UFDouble zero = new UFDouble(0);
      return value == null?zero:(UFDouble)value;
   }

   private static boolean isMainCfItem(CashflowcaseVO cfcasevo) throws BusinessException {
      CashflowVO cfvo = getCashflow(cfcasevo.getPk_cashflow());
      return cfvo.getItemflag() == null || cfvo.getItemflag().equals("Y");
   }

   private static String getName(DetailVO detail) {
      if(detail.getAccsubjname() == null) {
         AccountVO subjvo = (AccountVO)subj_map.get(detail.getPk_accasoa());
         return subjvo.getName();
      } else {
         return detail.getAccsubjname();
      }
   }

   public static boolean isNonCfSubj(DetailVO detailVO) {
      AccountVO subjvo = (AccountVO)subj_map.get(detailVO.getPk_accasoa());
      return subjvo.getCashtype() == null || subjvo.getCashtype().intValue() == 1 || subjvo.getCashtype().intValue() == 2;
   }

   public static final boolean isCurrentVoucherSettled(String pk_glorgbook, UFDate date) throws Exception {
      return false;
   }

}
